Index: syscalls.master
===================================================================
RCS file: /home/ncvs/src/sys/compat/freebsd32/syscalls.master,v
retrieving revision 1.72
diff -u -r1.72 syscalls.master
--- syscalls.master	3 Sep 2006 13:47:24 -0000	1.72
+++ syscalls.master	3 Sep 2006 15:01:57 -0000
@@ -238,8 +238,8 @@
 126	AUE_SETREUID	NOPROTO	{ int setreuid(int ruid, int euid); }
 127	AUE_SETREGID	NOPROTO	{ int setregid(int rgid, int egid); }
 128	AUE_RENAME	NOPROTO	{ int rename(char *from, char *to); }
-129	AUE_NULL	OBSOL	otruncate
-130	AUE_NULL	OBSOL	ftruncate
+129	AUE_TRUNCATE	OBSOL	otruncate
+130	AUE_FTRUNCATE	OBSOL	ftruncate
 131	AUE_FLOCK	NOPROTO	{ int flock(int fd, int how); }
 132	AUE_MKFIFO	NOPROTO	{ int mkfifo(char *path, int mode); }
 133	AUE_SENDTO	NOPROTO	{ int sendto(int s, caddr_t buf, \
@@ -256,17 +256,17 @@
 140	AUE_ADJTIME	STD	{ int freebsd32_adjtime( \
 				    struct timeval32 *delta, \
 				    struct timeval32 *olddelta); }
-141	AUE_NULL	OBSOL	ogetpeername
-142	AUE_NULL	OBSOL	ogethostid
-143	AUE_NULL	OBSOL	sethostid
-144	AUE_NULL	OBSOL	getrlimit
-145	AUE_NULL	OBSOL	setrlimit
-146	AUE_NULL	OBSOL	killpg
+141	AUE_GETPEERNAME	OBSOL	ogetpeername
+142	AUE_SYSCTL	OBSOL	ogethostid
+143	AUE_SYSCTL	OBSOL	sethostid
+144	AUE_GETRLIMIT	OBSOL	getrlimit
+145	AUE_SETRLIMIT	OBSOL	setrlimit
+146	AUE_KILLPG	OBSOL	killpg
 147	AUE_SETSID	NOPROTO	{ int setsid(void); }
 148	AUE_QUOTACTL	NOPROTO	{ int quotactl(char *path, int cmd, int uid, \
 				    caddr_t arg); }
-149	AUE_NULL	OBSOL oquota
-150	AUE_NULL	OBSOL ogetsockname
+149	AUE_O_QUOTA	OBSOL oquota
+150	AUE_GETSOCKNAME	OBSOL ogetsockname
 
 ; Syscalls 151-180 inclusive are reserved for vendor-specific
 ; system calls.  (This includes various calls added for compatibity
@@ -278,23 +278,23 @@
 154	AUE_NULL	UNIMPL	nosys
 ; 155 is initialized by the NFS code, if present.
 ; XXX this is a problem!!!
-155	AUE_NFSSVC	UNIMPL	nfssvc
-156	AUE_NULL	OBSOL	ogetdirentries
+155	AUE_NFS_SVC	UNIMPL	nfssvc
+156	AUE_GETDIRENTRIES	OBSOL	ogetdirentries
 157	AUE_STATFS	COMPAT4	{ int freebsd32_statfs(char *path, \
 				    struct statfs32 *buf); }
 158	AUE_FSTATFS	COMPAT4	{ int freebsd32_fstatfs(int fd, \
 				    struct statfs32 *buf); }
 159	AUE_NULL	UNIMPL	nosys
-160	AUE_NULL	UNIMPL	nosys
+160	AUE_LGETFH	UNIMPL	lgetfh
 161	AUE_NFS_GETFH	NOPROTO	{ int getfh(char *fname, \
 				    struct fhandle *fhp); }
-162	AUE_O_GETDOMAINNAME	NOPROTO	{ int getdomainname(char *domainname, \
+162	AUE_SYSCTL	NOPROTO	{ int getdomainname(char *domainname, \
 				    int len); }
-163	AUE_O_SETDOMAINNAME	NOPROTO	{ int setdomainname(char *domainname, \
+163	AUE_SYSCTL	NOPROTO	{ int setdomainname(char *domainname, \
 				    int len); }
 164	AUE_NULL	NOPROTO	{ int uname(struct utsname *name); }
-165	AUE_NULL	NOPROTO	{ int sysarch(int op, char *parms); }
-166	AUE_NULL	NOPROTO	{ int rtprio(int function, pid_t pid, \
+165	AUE_SYSARCH	NOPROTO	{ int sysarch(int op, char *parms); }
+166	AUE_RTPRIO	NOPROTO	{ int rtprio(int function, pid_t pid, \
 				    struct rtprio *rtp); }
 167	AUE_NULL	UNIMPL	nosys
 168	AUE_NULL	UNIMPL	nosys
@@ -542,7 +542,7 @@
 323	AUE_NULL	OBSOL	thr_wakeup
 324	AUE_MLOCKALL	NOPROTO	{ int mlockall(int how); }
 325	AUE_MUNLOCKALL	NOPROTO	{ int munlockall(void); }
-326	AUE_NULL	NOPROTO	{ int __getcwd(u_char *buf, u_int buflen); }
+326	AUE_GETCWD	NOPROTO	{ int __getcwd(u_char *buf, u_int buflen); }
 
 327	AUE_NULL	NOPROTO	{ int sched_setparam (pid_t pid, \
 				    const struct sched_param *param); }
@@ -567,7 +567,7 @@
 				    off_t *sbytes, int flags); }
 337	AUE_NULL	NOPROTO	{ int kldsym(int fileid, int cmd, \
 				    void *data); }
-338	AUE_NULL	NOPROTO	{ int jail(struct jail *jail); }
+338	AUE_JAIL	NOPROTO	{ int jail(struct jail *jail); }
 339	AUE_NULL	UNIMPL	pioctl
 340	AUE_SIGPROCMASK	NOPROTO	{ int sigprocmask(int how, \
 				    const sigset_t *set, sigset_t *oset); }
@@ -579,10 +579,10 @@
 344	AUE_SIGRETURN	COMPAT4	{ int freebsd32_sigreturn( \
 		    const struct freebsd4_freebsd32_ucontext *sigcntxp); }
 ; XXX implement
-345	AUE_NULL	UNIMPL	sigtimedwait
+345	AUE_SIGWAIT	UNIMPL	sigtimedwait
 ; XXX implement
 346	AUE_NULL	UNIMPL	sigwaitinfo
-347	AUE_JAIL	NOPROTO	{ int __acl_get_file(const char *path, \
+347	AUE_NULL	NOPROTO	{ int __acl_get_file(const char *path, \
 				    acl_type_t type, struct acl *aclp); }
 348	AUE_NULL	NOPROTO	{ int __acl_set_file(const char *path, \
 				    acl_type_t type, struct acl *aclp); }
@@ -598,24 +598,26 @@
 				    acl_type_t type, struct acl *aclp); }
 354	AUE_NULL	NOPROTO	{ int __acl_aclcheck_fd(int filedes, \
 				    acl_type_t type, struct acl *aclp); }
-355	AUE_NULL	NOPROTO	{ int extattrctl(const char *path, int cmd, \
+355	AUE_EXTATTRCTL	NOPROTO	{ int extattrctl(const char *path, int cmd, \
 				    const char *filename, int attrnamespace, \
 				    const char *attrname); }
-356	AUE_NULL	NOPROTO	{ int extattr_set_file(const char *path, \
-				    int attrnamespace, const char *attrname, \
-				    void *data, size_t nbytes); }
-357	AUE_NULL	NOPROTO	{ ssize_t extattr_get_file(const char *path, \
-				    int attrnamespace, const char *attrname, \
-				    void *data, size_t nbytes); }
-358	AUE_NULL	NOPROTO	{ int extattr_delete_file(const char *path, \
-				    int attrnamespace, \
+356	AUE_EXTATTR_SET_FILE	NOPROTO	{ int extattr_set_file( \
+				    const char *path, int attrnamespace, \
+				    const char *attrname, void *data, \
+				    size_t nbytes); }
+357	AUE_EXTATTR_GET_FILE	NOPROTO	{ ssize_t extattr_get_file( \
+				    const char *path, int attrnamespace, \
+				    const char *attrname, void *data, \
+				    size_t nbytes); }
+358	AUE_EXTATTR_DELETE_FILE	NOPROTO	{ int extattr_delete_file( \
+				    const char *path, int attrnamespace, \
 				    const char *attrname); }
 359	AUE_NULL	UNIMPL	aio_waitcomplete
-360	AUE_NULL	NOPROTO	{ int getresuid(uid_t *ruid, uid_t *euid, \
+360	AUE_GETRESUID	NOPROTO	{ int getresuid(uid_t *ruid, uid_t *euid, \
 				    uid_t *suid); }
-361	AUE_NULL	NOPROTO	{ int getresgid(gid_t *rgid, gid_t *egid, \
+361	AUE_GETRESGID	NOPROTO	{ int getresgid(gid_t *rgid, gid_t *egid, \
 				    gid_t *sgid); }
-362	AUE_NULL	NOPROTO	{ int kqueue(void); }
+362	AUE_KQUEUE	NOPROTO	{ int kqueue(void); }
 363	AUE_NULL	STD	{ int freebsd32_kevent(int fd, \
 				    const struct kevent32 *changelist, \
 				    int nchanges, \
@@ -628,20 +630,20 @@
 368	AUE_NULL	UNIMPL	__cap_set_fd
 369	AUE_NULL	UNIMPL	__cap_set_file
 370	AUE_NULL	UNIMPL	lkmressys
-371	AUE_NULL	NOPROTO	{ int extattr_set_fd(int fd, \
+371	AUE_EXTATTR_SET_FD	NOPROTO	{ int extattr_set_fd(int fd, \
 				    int attrnamespace, const char *attrname, \
 				    void *data, size_t nbytes); }
-372	AUE_NULL	NOPROTO	{ ssize_t extattr_get_fd(int fd, \
+372	AUE_EXTATTR_GET_FD	NOPROTO	{ ssize_t extattr_get_fd(int fd, \
 				    int attrnamespace, const char *attrname, \
 				    void *data, size_t nbytes); }
-373	AUE_NULL	NOPROTO	{ int extattr_delete_fd(int fd, \
+373	AUE_EXTATTR_DELETE_FD	NOPROTO	{ int extattr_delete_fd(int fd, \
 				    int attrnamespace, \
 				    const char *attrname); }
 374	AUE_NULL	NOPROTO	{ int __setugid(int flag); }
 375	AUE_NULL	UNIMPL	nfsclnt
-376	AUE_NULL	NOPROTO	{ int eaccess(char *path, int flags); }
+376	AUE_EACCESS	NOPROTO	{ int eaccess(char *path, int flags); }
 377	AUE_NULL	UNIMPL	afs_syscall
-378	AUE_NULL	NOPROTO	{ int nmount(struct iovec *iovp, \
+378	AUE_NMOUNT	NOPROTO	{ int nmount(struct iovec *iovp, \
 				    unsigned int iovcnt, int flags); }
 379	AUE_NULL	NOPROTO	{ int kse_exit(void); }
 380	AUE_NULL	NOPROTO	{ int kse_wakeup(struct kse_mailbox *mbx); }
@@ -661,7 +663,7 @@
 391	AUE_LCHFLAGS	NOPROTO	{ int lchflags(const char *path, int flags); }
 392	AUE_NULL	NOPROTO	{ int uuidgen(struct uuid *store, \
 				    int count); }
-393	AUE_NULL	STD	{ int freebsd32_sendfile(int fd, int s, \
+393	AUE_SENDFILE	STD	{ int freebsd32_sendfile(int fd, int s, \
 				    u_int32_t offsetlo, u_int32_t offsethi, \
 				    size_t nbytes, struct sf_hdtr32 *hdtr, \
 				    off_t *sbytes, int flags); }
@@ -671,7 +673,7 @@
 396	AUE_STATFS	NOPROTO	{ int statfs(char *path, \
 				    struct statfs *buf); }
 397	AUE_FSTATFS	NOPROTO	{ int fstatfs(int fd, struct statfs *buf); }
-398	AUE_NULL	NOPROTO	{ int fhstatfs(const struct fhandle *u_fhp, \
+398	AUE_FHSTATFS	NOPROTO	{ int fhstatfs(const struct fhandle *u_fhp, \
 				    struct statfs *buf); }
 399	AUE_NULL	UNIMPL	nosys
 ; XXX implement these?
@@ -687,9 +689,9 @@
 409	AUE_NULL	UNIMPL	__mac_get_pid
 410	AUE_NULL	UNIMPL	__mac_get_link
 411	AUE_NULL	UNIMPL	__mac_set_link
-412	AUE_NULL	UNIMPL	extattr_set_link
-413	AUE_NULL	UNIMPL	extattr_get_link
-414	AUE_NULL	UNIMPL	extattr_delete_link
+412	AUE_EXTATTR_SET_LINK	UNIMPL	extattr_set_link
+413	AUE_EXTATTR_GET_LINK	UNIMPL	extattr_get_link
+414	AUE_EXTATTR_DELETE_LINK	UNIMPL	extattr_delete_link
 415	AUE_NULL	UNIMPL	__mac_execve
 416	AUE_SIGACTION	STD	{ int freebsd32_sigaction(int sig, \
 				    struct sigaction32 *act, \
@@ -721,15 +723,15 @@
 434	AUE_NULL	NOPROTO	{ int _umtx_lock(struct umtx *umtx); }
 435	AUE_NULL	NOPROTO	{ int _umtx_unlock(struct umtx *umtx); }
 436	AUE_NULL	NOPROTO	{ int jail_attach(int jid); }
-437	AUE_NULL	UNIMPL	extattr_list_fd
-438	AUE_NULL	UNIMPL	extattr_list_file
-439	AUE_NULL	UNIMPL	extattr_list_link
+437	AUE_EXTATTR_LIST_FD	UNIMPL	extattr_list_fd
+438	AUE_EXTATTR_LIST_FILE	UNIMPL	extattr_list_file
+439	AUE_EXTATTR_LIST_LINK	UNIMPL	extattr_list_link
 440	AUE_NULL	UNIMPL	kse_switchin
 441	AUE_NULL	UNIMPL	ksem_timedwait
 442	AUE_NULL	NOPROTO	{ int thr_suspend( \
 				    const struct timespec *timeout); }
 443	AUE_NULL	NOPROTO	{ int thr_wake(long id); }
-444	AUE_NULL	NOPROTO	{ int kldunloadf(int fileid, int flags); }
+444	AUE_MODUNLOAD	NOPROTO	{ int kldunloadf(int fileid, int flags); }
 445	AUE_AUDIT	UNIMPL	audit
 446	AUE_AUDITON	UNIMPL	auditon
 447	AUE_GETAUID	UNIMPL	getauid