? keymap.h
? rtermcap
? makedevs.c
? sysinstall
? sysinstall.8.gz
? inetd_defaults.diff
? bak
Index: anonFTP.c
===================================================================
RCS file: /home/ncvs/src/usr.sbin/sysinstall/anonFTP.c,v
retrieving revision 1.30
diff -u -r1.30 anonFTP.c
--- anonFTP.c	2001/07/05 09:51:08	1.30
+++ anonFTP.c	2001/08/02 03:07:39
@@ -238,6 +238,19 @@
 configAnonFTP(dialogMenuItem *self)
 {
     int i;
+
+
+    if (msgYesNo("Anonymous FTP permits un-authenticated users to connect to the system\n"
+		 "FTP server, if FTP service is enabled.  Anonymous users are\n"
+		 "restricted to a specific subset of the file system, and the default\n"
+		 "configuration provides a drop-box incoming directory to which uploads\n"
+		 "are permitted.  You must seperately enable both inetd(8), and enable\n"
+		 "ftpd(8) in inetd.conf(5) for FTP services to be available.  If you\n"
+		 "did not do so earlier, you will have the opportunity to enable inetd(8)\n"
+		 "again later.\n\n"
+		 "Do you wish to continue configuring anonymous FTP?")) {
+	return DITEM_FAILURE;
+    }
     
     /* Be optimistic */
     i = DITEM_SUCCESS;
Index: config.c
===================================================================
RCS file: /home/ncvs/src/usr.sbin/sysinstall/config.c,v
retrieving revision 1.183
diff -u -r1.183 config.c
--- config.c	2001/07/17 04:09:50	1.183
+++ config.c	2001/08/02 03:07:51
@@ -955,6 +955,39 @@
 }
 
 int
+configInetd(dialogMenuItem *self)
+{
+    char cmd[256];
+
+    WINDOW *w = savescr();
+
+    if (msgYesNo("The Internet Super Server (inetd) allows a number of simple Internet\n"
+                 "services to be enabled, including finger, ftp, and telnetd.  Enabling\n"
+                 "these services may increase risk of security problems by increasing\n"
+                 "the exposure of your system.\n\n"
+                 "With this in mind, do you wish to enable inetd?\n")) {
+        variable_set2("inetd_enable", "NO", 1);
+    } else {
+        /* If inetd is enabled, we'll need an inetd.conf */
+
+	if (!msgYesNo("inetd(8) relies on its configuration file, /etc/inetd.conf, to determine\n"
+                   "which of its Internet services will be available.  The default FreeBSD\n"
+                   "inetd.conf(5) leaves all services disabled by default, so they must be\n"
+                   "specifically enabled in the configuration file before they will\n"
+                   "function, even once inetd(8) is enabled.  Note that services for\n"
+		   "IPv6 must be seperately enabled from IPv4 services.\n\n"
+                   "Select [Yes] now to invoke an editor on /etc/inetd.conf, or [No] to\n"
+                   "use the current settings.\n")) {
+            sprintf(cmd, "%s /etc/inetd.conf", variable_get(VAR_EDITOR));
+            dialog_clear();
+            systemExecute(cmd);
+            variable_set2("inetd_enable", "YES", 1);
+	}
+    }
+    restorescr(w);
+}
+
+int
 configNFSServer(dialogMenuItem *self)
 {
     char cmd[256];
Index: dispatch.c
===================================================================
RCS file: /home/ncvs/src/usr.sbin/sysinstall/dispatch.c,v
retrieving revision 1.38
diff -u -r1.38 dispatch.c
--- dispatch.c	2001/07/05 09:51:09	1.38
+++ dispatch.c	2001/08/02 03:07:54
@@ -52,6 +52,7 @@
 } resWords[] = {
     { "configAnonFTP",		configAnonFTP		},
     { "configRouter",		configRouter		},
+    { "configInetd",		configInetd		},
     { "configNFSServer",	configNFSServer		},
     { "configNTP",		configNTP		},
     { "configPCNFSD",		configPCNFSD		},
Index: install.c
===================================================================
RCS file: /home/ncvs/src/usr.sbin/sysinstall/install.c,v
retrieving revision 1.300
diff -u -r1.300 install.c
--- install.c	2001/07/17 04:09:50	1.300
+++ install.c	2001/08/02 03:08:11
@@ -573,6 +573,10 @@
 	variable_set2("gateway_enable", "YES", 1);
 
     dialog_clear_norefresh();
+    if (!msgNoYes("Do you want to configure inetd and simple internet services?"))
+        configInetd(self);
+
+    dialog_clear_norefresh();
     if (!msgNoYes("Do you want to have anonymous FTP access to this machine?"))
 	configAnonFTP(self);
 
Index: menus.c
===================================================================
RCS file: /home/ncvs/src/usr.sbin/sysinstall/menus.c,v
retrieving revision 1.310
diff -u -r1.310 menus.c
--- menus.c	2001/07/31 21:30:57	1.310
+++ menus.c	2001/08/02 03:09:03
@@ -235,6 +235,7 @@
       { " FTP sites",		"The FTP mirror site listing.",		NULL, dmenuSubmenu, NULL, &MenuMediaFTP },
       { " Gateway",		"Set flag to route packets between interfaces.", dmenuVarCheck, dmenuToggleVariable, NULL, "gateway=YES" },
       { " HTML Docs",		"The HTML documentation menu",		NULL, docBrowser },
+      { " inetd Configuration",	"Configure inetd and simple internet services.",	dmenuVarCheck, configInetd, NULL, "inetd_enable=YES" },
       { " Install, Standard",	"A standard system installation.",	NULL, installStandard },
       { " Install, Express",	"An express system installation.",	NULL, installExpress },
       { " Install, Custom",	"The custom installation menu",		NULL, dmenuSubmenu, NULL, &MenuInstallCustom },
@@ -1332,7 +1333,7 @@
       { " Gateway",	"This machine will route packets between interfaces",
 	dmenuVarCheck,	dmenuToggleVariable, NULL, "gateway_enable=YES" },
       { " inetd",	"This machine wants to run the inet daemon",
-	dmenuVarCheck,	dmenuToggleVariable, NULL, "inetd_enable=YES" },
+	dmenuVarCheck,	configInetd, NULL, "inetd_enable=YES" },
       { " NFS client",	"This machine will be an NFS client",
 	dmenuVarCheck,	dmenuToggleVariable, NULL, "nfs_client_enable=YES" },
       { " NFS server",	"This machine will be an NFS server",
Index: sysinstall.h
===================================================================
RCS file: /home/ncvs/src/usr.sbin/sysinstall/sysinstall.h,v
retrieving revision 1.209
diff -u -r1.209 sysinstall.h
--- sysinstall.h	2001/07/17 04:09:50	1.209
+++ sysinstall.h	2001/08/02 03:09:17
@@ -447,6 +447,7 @@
 extern int	configXDesktop(dialogMenuItem *self);
 extern int	configRouter(dialogMenuItem *self);
 extern int	configPCNFSD(dialogMenuItem *self);
+extern int	configInetd(dialogMenuItem *self);
 extern int	configNFSServer(dialogMenuItem *self);
 extern int	configWriteRC_conf(dialogMenuItem *self);
 extern int	configSecurityProfile(dialogMenuItem *self);